/* Hey Emacs! This is -*- c -*- ! :-) */
/* c_gmp_glue.c	-- Hans-Peter Stoerr Fri May 19 1995
 * 
 * $Id: c_gmp_glue.c,v 1.4 1995/08/10 15:00:05 haps Exp $
 *
 * 
 */
/* This is some glue code for using the GNU MP Library with
 * Sather. See inti_gmp.sa.
 */

#include <limits.h>
#include <gmp.h>

#include <gc.h>

/* indicates if initialization is done. */
static  int     gmp_glue_doneinit=0;

/* Wrapper for the GC functions to make them compatible with
 * malloc etc. */

void    *gmp_glue_malloc(size_t siz)
{
  return GC_MALLOC(siz);
}

void    *gmp_glue_realloc(void *ptr,size_t old, size_t new)
{
  return GC_REALLOC(ptr,new);
#if 0
  void *res=GC_malloc(new);
  if(res) memmove(res,ptr,(old<new ? old : new));
#endif
}

void    gmp_glue_free(void *ptr, size_t siz)
{
  GC_FREE(ptr);
}

/* This is allocates an MP_INT and returns the pointer. */
void    *gmp_glue_alloc_int()
{

  MP_INT        *p;
  if(!gmp_glue_doneinit){
    mp_set_memory_functions(gmp_glue_malloc,gmp_glue_realloc,gmp_glue_free);
    gmp_glue_doneinit=1;
  }
  p=GC_MALLOC(sizeof(MP_INT));
  mpz_init(p);
  return p;
}

/* returns the size of a MP limb in bits. */
int    gmp_glue_limb_bits()
{
  return sizeof(mp_limb)*CHAR_BIT/sizeof(char); /* a little bit paranoid :-) */
}

void    *gmp_glue_nullp()
{
  return NULL;
}

int     gmp_glue_is_nullp(void *ptr)
{
  return NULL==ptr;
}
